/*
 * gnome-hdaps-applet
 * 2006-01-20
 * Copyright (C) 2006 Jon Escombe <lists@dresco.co.uk>
 */

#include <fcntl.h>
#include <string.h>
#include <panel-applet.h>
#include <gtk/gtk.h>

#define BUF_LEN					32
#define SYSFS_PROTECT_FILE_HDA	"/sys/block/hda/queue/protect"
#define SYSFS_PROTECT_FILE_SDA	"/sys/block/sda/queue/protect"

int check_status ()
{
	int fd, ret;
	char buf[BUF_LEN];

	memset(buf, 0, sizeof(buf));
	if ((fd = open (SYSFS_PROTECT_FILE_HDA, O_RDONLY)) < 1)
		if ((fd = open (SYSFS_PROTECT_FILE_SDA, O_RDONLY)) < 1)
			return -1;
	
	ret = read (fd, buf, BUF_LEN);
	close (fd);
	return atoi(buf);
}

gboolean timer_func (gpointer gdata)
{
	GtkWidget *image = gdata;
	static int timerval = 0;
	gchar *text_label;
	int status;

	status = check_status();
	if (status < 0)
			gtk_image_set_from_file (GTK_IMAGE (image), "/usr/share/pixmaps/gnome-hdaps-applet/hdaps-error-small.png");
	else if (!status)
			gtk_image_set_from_file (GTK_IMAGE (image), "/usr/share/pixmaps/gnome-hdaps-applet/hdaps-running-small.png");
	else if (status)
			gtk_image_set_from_file (GTK_IMAGE (image), "/usr/share/pixmaps/gnome-hdaps-applet/hdaps-paused-small.png");

	return TRUE;
}

static gboolean gnome_hdaps_applet_fill (PanelApplet *applet, const gchar *iid, gpointer data)
{
	GtkWidget *image;
	guint timer;

	if (strcmp (iid, "OAFIID:GNOME_HDAPS_STATUSApplet") != 0)
		return FALSE;

	image = gtk_image_new_from_file ("/usr/share/pixmaps/gnome-hdaps-applet/hdaps-error-small.png");
	gtk_container_add (GTK_CONTAINER (applet), image);
	gtk_widget_show_all (GTK_WIDGET (applet));

	timer = g_timeout_add (100, timer_func, (gpointer) image);

	return TRUE;
}

PANEL_APPLET_BONOBO_FACTORY ("OAFIID:GNOME_HDAPS_STATUS_Factory",
                             PANEL_TYPE_APPLET,
                             "HDAPS Status Applet",
                             "0",
                             gnome_hdaps_applet_fill,
                             NULL);
